#!/usr/bin/python2.4

import sys
import os
import glob
import config
import re
from pkg_tools import pkg_tools

r1 = re.compile(r"^(Working on binary package )'([^']+)'(, version .*)", re.DOTALL)
r2 = re.compile(r"^(  \* Could not find file for soname ')([^']+)'", re.DOTALL)
r3 = re.compile(r"^(Exception: No package could be instantiated for dependency )'\['([^']+)'\]'", re.DOTALL)
r4 = re.compile(r"^(    Resolved Deps: )(.*)", re.DOTALL)

def filter_log(fin, fout, pkgfile):
    print fin.name
    fout.write("""
       <html>
       <head>
       <title>%s</title>
       </head>
       <body><pre>""" % os.path.basename(fout.name))

    current_package = None
    for line in fin:
        m1 = r1.search(line)
        if m1:
            start, pkgname, end = m1.groups()
            current_package = pkgname
            line = ''.join([
                    start,
                    "'<a href='http://packages.debian.org/", pkgname, "'>", pkgname, "</a>' (", 
                    "<a href='http://packages.debian.org/src:", pkgfile.get(pkgname, {}).get("Source", "NULL"), "'>Source</a>)", 
                    end])

        m2 = r2.search(line)
        if m2:
            start, filename = m2.groups()
            line = ''.join([
                        start, 
                        "<a href='http://packages.debian.org/cgi-bin/search_contents.pl?word=", 
                        filename,
                        "&searchmode=searchfiles&case=insensitive&version=unstable&arch=i386'>",
                        filename, "</a>'\n"
                    ])

        m3 = r3.search(line)
        if m3:
            start, pkgname = m3.groups()
            line = ''.join([start, "'<a href='http://packages.debian.org/", pkgname, "'>", pkgname, 
                    "</a>' (<a href='http://qa.debian.org/debcheck.php?dist=sid&package=",
                    current_package,
                    "'>debcheck</a>)\n"])

        m4 = r4.search(line)
        if m4:
            start, pkgnames = m4.groups()
            pkgnames = pkgnames.strip().split(', ')
            pkgnames = ["<a href='http://packages.debian.org/"+i+"'>"+i+"</a>" for i in pkgnames]
            line = ''.join([start, ', '.join(pkgnames), "\n"])
        
        fout.write(line)

    fout.write("</pre></body></html>")

def main():
    all_logs = glob.glob(os.path.join(config.Logdir, 'log.*.txt'))
    all_parsed = glob.glob(os.path.join(config.Logdir, 'log.*.html'))
    all_parsed = dict(((i, None) for i in all_parsed))

    print "Parsing 'Packages' file"
    try:
        pkgfile = pkg_tools.PackagesFile(config.pkg_file_name)
    except IOError:
        tmppath = os.path.join(config.Cache, 'Packages')
        pkgfile = pkg_tools.PackagesFile(tmppath)

    for log in all_logs:
        html = log[:-3] + 'html'
        if html in all_parsed:
            continue
        
        infile = file(log)
        outfile = file(html, 'w')
        filter_log(infile, outfile, pkgfile)

if __name__ == '__main__':
    main()
