#!/usr/bin/python
# objinfo.py - Functions for interfacing with objectinfo
#              Used by checklib.py and friends.
# Copyright (C) 2006  Christian Aichinger <Greek0@gmx.net>
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; version 2 of the License.
# 
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# 
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 51
# Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

import sys
import os
import popen2

OBJINFO = 'build/out/objinfo'

def run_generic(filename, cmdline):
    proc = popen2.Popen3(cmdline, True)

    fname = proc.fromchild.readline().strip()
    if filename != fname:
        print fname
        print filename
        print "XXX"
        print proc.fromchild.read()
        print "XXX"
        print cmdline
        assert False

    for line in proc.fromchild:
        yield line

    exitval = proc.wait()
    assert exitval == 0

def get_exported(filename):
    cmdline = [OBJINFO, '-n', '-m', '-C', filename]
    return run_generic(filename, cmdline)

def get_relocations(filename):
    cmdline = [OBJINFO, '-n', '-m', '-B', filename]
    return run_generic(filename, cmdline)

def get_dynamic(filename):
    cmdline = [OBJINFO, '-n', '-m', '-E', filename]
    return run_generic(filename, cmdline)
