/* sparse_array.h - prototypes for the sparse_array stuff
   Copyright (C) 2006 Christian Aichinger <Greek0@gmx.net>

   This program is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free Software
   Foundation; version 2 of the License.

   This program is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
   FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
   details.

   You should have received a copy of the GNU General Public License along with
   this program; if not, write to the Free Software Foundation, Inc., 51
   Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
   */

#ifndef __SEEN_SPARSE_ARRAY_H
#define __SEEN_SPARSE_ARRAY_H

// if enabled do some extra checks.
#define SARRAY_WARNINGS 1

typedef unsigned long int sa_key_t;
typedef struct sarray_entry sarray_entry;
typedef struct sarray_head *sarray;

sarray sarray_new();
void   sarray_free(sarray a);

sarray_entry *sarray_first(sarray a);
sarray_entry *sarray_next(sarray_entry *entry);
unsigned long int sarray_count(sarray a);

sa_key_t sarray_key  (sarray_entry *entry);
void*    sarray_value(sarray_entry *entry);

void sarray_insert(sarray a, sa_key_t key, void* value);
void *sarray_find(sarray a, sa_key_t key);

#endif 	/* __SEEN_SPARSE_ARRAY_H */
