/* versioniter.h - prototypes for the verdef/verneed iterators
   Copyright (C) 2006 Christian Aichinger <Greek0@gmx.net>

   This program is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free Software
   Foundation; version 2 of the License.

   This program is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
   FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
   details.

   You should have received a copy of the GNU General Public License along with
   this program; if not, write to the Free Software Foundation, Inc., 51
   Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
   */

#ifndef __SEEN_VERSIONITER_H
#define __SEEN_VERSIONITER_H

typedef struct UElf_Verdef_Iter {
    unsigned int count;
    unsigned int offset;
    GElf_Verdef *def;

    unsigned int auxcount;
    unsigned int auxoffset;
    GElf_Verdaux *aux;

    unsigned int _offset;
    unsigned int _auxoffset;
    GElf_Verdef defmem;
    GElf_Verdaux auxmem;
} UElf_Verdef_Iter;

typedef struct UElf_Verneed_Iter {
    unsigned int count;
    unsigned int offset;
    GElf_Verneed *need;

    unsigned int auxcount;
    unsigned int auxoffset;
    GElf_Vernaux *aux;


    unsigned int _offset;
    unsigned int _auxoffset;
    GElf_Verneed needmem;
    GElf_Vernaux auxmem;
} UElf_Verneed_Iter;

const UElf_Verdef_Iter UElf_Verdef_Iter_INIT;
const UElf_Verneed_Iter UElf_Verneed_Iter_INIT;

bool iter_verdef(UElf_File *efile, UElf_Section *section, UElf_Verdef_Iter *iter);
bool iter_verdefaux(UElf_File *efile, UElf_Section *section, UElf_Verdef_Iter *iter);
bool iter_verneed(UElf_File *efile, UElf_Section *section, UElf_Verneed_Iter *iter);
bool iter_verneedaux(UElf_File *efile, UElf_Section *section, UElf_Verneed_Iter *iter);

#endif // __SEEN_VERSIONITER_H
